Title Error when compiling with --standalone on FreeBSD
Priority bug Status resolved
Superseder Nosy List adamrfox, kayhayen
Assigned To kayhayen Keywords standalone

Created on 2016-02-25.03:15:13 by adamrfox, last changed by kayhayen.

msg1903 (view) Author: kayhayen Date: 2016-04-18.18:24:25
Released as stable.
msg1863 (view) Author: kayhayen Date: 2016-03-06.10:31:35
Just made a pre-release with this included.
msg1855 (view) Author: kayhayen Date: 2016-03-05.10:48:28
Hello there, 

I just pushed to the factory git branch some improvements that make standalone and its testing work 
on FreeBSD.

I installed a minimal 10.2 release with git only, which pulled in python2.7 already, which was 
sufficient for Nuitka already. You have to run it was "python2.7 bin/nuitka" but that is about it.

The use of "dtruss" over "strace" affected testing only. But there was also a bug when detecting the 
program directory, where the FreeBSD code path was giving the program full path, and a dirname call 
was missing. The "ldd" parsing had a TODO that it might work for FreeBSD as well (already used for 
NetBSD), and that is indeed the case.

Seems unlike NetBSD, the origin linking works fine, so this can now be considered supported.

msg1837 (view) Author: kayhayen Date: 2016-02-25.12:53:12
That function needs implementing on FreeBSD. I think in this case, just somebody to 
look at ldd output and see if it matches what we have on Linux.

msg1836 (view) Author: adamrfox Date: 2016-02-25.03:15:13
Ok, so I have a very simple program that complies fine with --recurse-all.  But I 
want to build a stand-alone version and I'm getting error messages.  I have a module 
in the same directory as the script that is imported in the script which is probably 
the only odd thing about it.

Nuitka Version:  0.5.19
Python: 2.7.11
FreeBSD v10.2 (amd64)

Error Message:
root@freebsd:~/py_testing # nuitka --recurse-all --standalone
Traceback (most recent call last):
  File "/usr/local/bin/nuitka", line 193, in <module>
  File "/usr/local/lib/python2.7/site-packages/nuitka/", line 746, in 
    standalone_entry_points = standalone_entry_points
  File "/usr/local/lib/python2.7/site-packages/nuitka/freezer/", line 
805, in copyUsedDLLs
    used_dlls = detectUsedDLLs(standalone_entry_points)
  File "/usr/local/lib/python2.7/site-packages/nuitka/freezer/", line 
711, in detectUsedDLLs
    package_name    = package_name
  File "/usr/local/lib/python2.7/site-packages/nuitka/freezer/", line 
702, in detectBinaryDLLs
    assert False, Utils.getOS()
AssertionError: FreeBSD
root@freebsd:~/py_testing # 

Here's the main code if that helps.


import papi
import sys
import getpass
import json
import time

username = 'root'
password = 'a'
host = ''
port = '8080'

(status, reason, resp) = (host, port, 'GET', 
"/namespace/ifs/isi_lwswift/swift?acl", '', 'any', 'text/plain', username, password)
metadata = json.loads(resp)
print "META=",metadata['authoritative']
(status, reason, resp2) = (host, port, 'PUT', 
"/namespace/ifs/isi_lwswift/swift?acl", resp, 'any', 'application/json', username, 
print "STATUS=",status
Date User Action Args
2016-04-18 18:24:25kayhayensetstatus: testing -> resolved
messages: + msg1903
2016-03-06 10:31:35kayhayensetmessages: + msg1863
2016-03-05 10:48:40kayhayensetstatus: resolved -> testing
2016-03-05 10:48:28kayhayensetstatus: chatting -> resolved
keyword: + standalone
nosy: + kayhayen
messages: + msg1855
priority: urgent -> bug
assignedto: kayhayen
2016-02-25 12:53:12kayhayensetstatus: unread -> chatting
messages: + msg1837
2016-02-25 03:15:13adamrfoxcreate